// Counts word frequencies in input.
#include "Dict.h"

#include <algorithm>
#include <iostream>
#include <utility>

using namespace std;
using namespace dictionary;

int main()
{
    Dict freqs;

    for (string word; cin >> word && word != "eof"; ) {
        ++freqs[word];
    }

    vector<pair<string, unsigned>> freqs_sorted;

    for (const string& word : freqs.get_keys()) {
        freqs_sorted.emplace_back(word, freqs[word]);
    }

    sort(begin(freqs_sorted), end(freqs_sorted), [](const auto& a, const auto& b) {
        if (a.second > b.second) return true;
        if (a.second < b.second) return false;
        return a.first < b.first;
    });

    for (const auto& each : freqs_sorted) {
        cout << each.first << ": " << each.second << '\n';
    }
}
